import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerSetting, DealerSettingParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商设置表
 */
export async function pageDealerSetting(params: DealerSettingParam) {
  const res = await request.get<ApiResult<PageResult<DealerSetting>>>(
    MODULES_API_URL + '/shop/dealer-setting/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商设置表列表
 */
export async function listDealerSetting(params?: DealerSettingParam) {
  const res = await request.get<ApiResult<DealerSetting[]>>(
    MODULES_API_URL + '/shop/dealer-setting',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商设置表
 */
export async function addDealerSetting(data: DealerSetting) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-setting',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商设置表
 */
export async function updateDealerSetting(data: DealerSetting) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-setting',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商设置表
 */
export async function removeDealerSetting(id?: string) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-setting/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商设置表
 */
export async function removeBatchDealerSetting(data: (string | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-setting/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商设置表
 */
export async function getDealerSetting(id: string) {
  const res = await request.get<ApiResult<DealerSetting>>(
    MODULES_API_URL + '/shop/dealer-setting/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
